edu.isi.pegasus.planner.invocation

## Class Usage

- java.lang.Object
- - org.griphyn.vdl.Chimera
  - - edu.isi.pegasus.planner.invocation.Invocation
    - - edu.isi.pegasus.planner.invocation.Usage

All Implemented Interfaces:
  java.io.Serializable

    public class Usage
    extends Invocation

This class is contains some excerpt from the getrusage call. Due to Linux not populating a lot of records, the amount of information is restricted. Adjustments to LP64 architecture may be necessary.

Version:
  $Revision$
Author:
  Jens-S. Vöckler, Yong Zhao
See Also:
  Serialized Form

### Field Summary

Fields
`private int` `m_idrss` integral unshared data size, or private integral resident set size.
`private int` `m_inblock` block input operations.
`private int` `m_isrss` integral stoack size.
`private int` `m_ixrss` integral shared memory size.
`private int` `m_majflt` major page faults - incurred subsystem IO, sometimes includes swap.
`private int` `m_maxrss` maximum resident set size.
`private int` `m_minflt` minor page faults - sometimes also recovered pages.
`private int` `m_msgrcv` messages received.
`private int` `m_msgsnd` messages sent.
`private int` `m_nivcsw` involuntary conext switches.
`private int` `m_nsignals` number of signals sent to process.
`private int` `m_nswap` number of swap operations - unused in Linux unless kernel patched.
`private int` `m_nvcsw` voluntary context switches.
`private int` `m_outblock` block output operations.
`private double` `m_stime` system time - time spent in system mode, seconds with fraction.
`private double` `m_utime` user time - time spent in user mode, seconds with fraction.

### Constructor Summary

Constructors
Constructor and Description
`Usage()` Default c'tor: Construct a hollow shell and allow further information to be added later.
`Usage(double utime, double stime, int minflt, int majflt, int nswap, int nsignals, int nvcsw, int nivcsw, int maxrss, int ixrss, int idrss, int isrss, int inblock, int outblock, int msgsnd, int msgrcv)` Full c'tor: All values are provided.

### Method Summary

All Methods Instance Methods Concrete Methods
`int` `getInputBlocks()` Accessor.
`int` `getInvoluntarySwitches()` Accessor: Obtains the involuntary context switches.
`int` `getMajorFaults()` Accessor: Obtains the major page faults.
`int` `getMaximumRSS()` Accessor.
`int` `getMinorFaults()` Accessor: Obtains the minfor page faults.
`int` `getOutputBlocks()` Accessor.
`int` `getReceived()` Accessor.
`int` `getSent()` Accessor.
`int` `getSharedRSS()` Accessor.
`int` `getSignals()` Accessor: Obtains the system signals sent.
`int` `getStackRSS()` Accessor.
`int` `getSwaps()` Accessor: Obtains number of swap operations.
`double` `getSystemTime()` Accessor: Obtains the system time from the object.
`int` `getUnsharedRSS()` Accessor.
`double` `getUserTime()` Accessor: Obtains the user time from the object.
`int` `getVoluntarySwitches()` Accessor: Obtains the voluntary context switches.
`void` `setInputBlocks(int inblock)` Accessor.
`void` `setInvoluntarySwitches(int nivcsw)` Accessor: Sets the number of involuntary context switches.
`void` `setMajorFaults(int majflt)` Accessor: Sets the number of major page faults.
`void` `setMaximumRSS(int maxrss)` Accessor.
`void` `setMinorFaults(int minflt)` Accessor: Sets the number of minor faults.
`void` `setOutputBlocks(int outblock)` Accessor.
`void` `setReceived(int msgrcv)` Accessor.
`void` `setSent(int msgsnd)` Accessor.
`void` `setSharedRSS(int ixrss)` Accessor.
`void` `setSignals(int nsignals)` Accessor: Sets the number of signalss sent.
`void` `setStackRSS(int isrss)` Accessor.
`void` `setSwaps(int nswap)` Accessor: Sets the number of swap ops.
`void` `setSystemTime(double stime)` Accessor: Sets the system time.
`void` `setUnsharedRSS(int idrss)` Accessor.
`void` `setUserTime(double utime)` Accessor: Sets the user time.
`void` `setVoluntarySwitches(int nvcsw)` Accessor: Sets the number of voluntary context switches.
`void` `toString(java.io.Writer stream)` Converts the active state into something meant for human consumption.
`void` `toXML(java.io.Writer stream, java.lang.String indent, java.lang.String namespace)` Dump the state of the current element as XML output.

### Methods inherited from class org.griphyn.vdl.Chimera

`escape, quote, toString, toXML, toXML, writeAttribute`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

### Field Detail

#### m_utime

    private double m_utime

user time - time spent in user mode, seconds with fraction.

#### m_stime

    private double m_stime

system time - time spent in system mode, seconds with fraction.

#### m_minflt

    private int m_minflt

minor page faults - sometimes also recovered pages.

#### m_majflt

    private int m_majflt

major page faults - incurred subsystem IO, sometimes includes swap.

#### m_nswap

    private int m_nswap

number of swap operations - unused in Linux unless kernel patched.

#### m_nsignals

    private int m_nsignals

number of signals sent to process.

#### m_nvcsw

    private int m_nvcsw

voluntary context switches.

#### m_nivcsw

    private int m_nivcsw

involuntary conext switches.

#### m_maxrss

    private int m_maxrss

maximum resident set size.

#### m_ixrss

    private int m_ixrss

integral shared memory size.

#### m_idrss

    private int m_idrss

integral unshared data size, or private integral resident set size.

#### m_isrss

    private int m_isrss

integral stoack size.

#### m_inblock

    private int m_inblock

block input operations.

#### m_outblock

    private int m_outblock

block output operations.

#### m_msgsnd

    private int m_msgsnd

messages sent.

#### m_msgrcv

    private int m_msgrcv

messages received.

### Constructor Detail

#### Usage

    public Usage()

Default c'tor: Construct a hollow shell and allow further information to be added later.

#### Usage

    public Usage(double utime,
                 double stime,
                 int minflt,
                 int majflt,
                 int nswap,
                 int nsignals,
                 int nvcsw,
                 int nivcsw,
                 int maxrss,
                 int ixrss,
                 int idrss,
                 int isrss,
                 int inblock,
                 int outblock,
                 int msgsnd,
                 int msgrcv)

Full c'tor: All values are provided.

Parameters:
  `utime` - is the time spent in user mode
  `stime` - is the time spent in system mode
  `minflt` - are minor page faults and page reclaims
  `majflt` - are major page faults and s.t. swaps
  `nswap` - are the number of swap operations
  `nsignals` - are the number of signals sent
  `nvcsw` - are voluntary context switches
  `nivcsw` - are involuntary context switches
  `maxrss` - is the maximum resident set size
  `ixrss` - is the integral shared memory size
  `idrss` - is the integral unshared data size
  `isrss` - is the integral unshared stack size
  `inblock` - are block input operations
  `outblock` - are block output operations
  `msgsnd` - are messages sent
  `msgrcv` - are messages received

### Method Detail

#### getUserTime

    public double getUserTime()

Accessor: Obtains the user time from the object.

Returns:
  the time spent in user mode.
See Also:
  `setUserTime(double)`

#### getSystemTime

    public double getSystemTime()

Accessor: Obtains the system time from the object.

Returns:
  the time spent in system mode.
See Also:
  `setSystemTime(double)`

#### getMinorFaults

    public int getMinorFaults()

Accessor: Obtains the minfor page faults.

Returns:
  the number of page reclaims.
See Also:
  `setMinorFaults(int)`

#### getMajorFaults

    public int getMajorFaults()

Accessor: Obtains the major page faults.

Returns:
  the number of major page faults.
See Also:
  `setMajorFaults(int)`

#### getSwaps

    public int getSwaps()

Accessor: Obtains number of swap operations.

Returns:
  the number of swaps.
See Also:
  `setSwaps(int)`

#### getSignals

    public int getSignals()

Accessor: Obtains the system signals sent.

Returns:
  the number of signals sent to the process.
See Also:
  `setSignals(int)`

#### getVoluntarySwitches

    public int getVoluntarySwitches()

Accessor: Obtains the voluntary context switches.

Returns:
  the number of voluntary context switches.
See Also:
  `setVoluntarySwitches(int)`

#### getInvoluntarySwitches

    public int getInvoluntarySwitches()

Accessor: Obtains the involuntary context switches.

Returns:
  the number of involuntary context switches.
See Also:
  `setInvoluntarySwitches(int)`

#### setUserTime

    public void setUserTime(double utime)

Accessor: Sets the user time.

Parameters:
  `utime` - is the new user time in seconds with fraction.
See Also:
  `getUserTime()`

#### setSystemTime

    public void setSystemTime(double stime)

Accessor: Sets the system time.

Parameters:
  `stime` - is the new user time in seconds with fraction.
See Also:
  `getSystemTime()`

#### setMinorFaults

    public void setMinorFaults(int minflt)

Accessor: Sets the number of minor faults.

Parameters:
  `minflt` - is the new number of minor faults.
See Also:
  `getMinorFaults()`

#### setMajorFaults

    public void setMajorFaults(int majflt)

Accessor: Sets the number of major page faults.

Parameters:
  `majflt` - is the new number of major page faults.
See Also:
  `getMajorFaults()`

#### setSwaps

    public void setSwaps(int nswap)

Accessor: Sets the number of swap ops.

Parameters:
  `nswap` - is the new number of swap operations.
See Also:
  `getSwaps()`

#### setSignals

    public void setSignals(int nsignals)

Accessor: Sets the number of signalss sent.

Parameters:
  `nsignals` - is the new number of signals.
See Also:
  `getSignals()`

#### setVoluntarySwitches

    public void setVoluntarySwitches(int nvcsw)

Accessor: Sets the number of voluntary context switches.

Parameters:
  `nvcsw` - is the new number voluntary context switches.
See Also:
  `getVoluntarySwitches()`

#### setInvoluntarySwitches

    public void setInvoluntarySwitches(int nivcsw)

Accessor: Sets the number of involuntary context switches.

Parameters:
  `nivcsw` - is the new number involuntary context switches.
See Also:
  `getInvoluntarySwitches()`

#### getMaximumRSS

    public int getMaximumRSS()

Accessor.

See Also:
  `setMaximumRSS(int)`

#### setMaximumRSS

    public void setMaximumRSS(int maxrss)

Accessor.

Parameters:
  `maxrss` -
See Also:
  `getMaximumRSS()`

#### getSharedRSS

    public int getSharedRSS()

Accessor.

See Also:
  `setSharedRSS(int)`

#### setSharedRSS

    public void setSharedRSS(int ixrss)

Accessor.

Parameters:
  `ixrss` -
See Also:
  `getSharedRSS()`

#### getUnsharedRSS

    public int getUnsharedRSS()

Accessor.

See Also:
  `setUnsharedRSS(int)`

#### setUnsharedRSS

    public void setUnsharedRSS(int idrss)

Accessor.

Parameters:
  `idrss` -
See Also:
  `getUnsharedRSS()`

#### getStackRSS

    public int getStackRSS()

Accessor.

See Also:
  `setStackRSS(int)`

#### setStackRSS

    public void setStackRSS(int isrss)

Accessor.

Parameters:
  `isrss` -
See Also:
  `getStackRSS()`

#### getInputBlocks

    public int getInputBlocks()

Accessor.

See Also:
  `setInputBlocks(int)`

#### setInputBlocks

    public void setInputBlocks(int inblock)

Accessor.

Parameters:
  `inblock` -
See Also:
  `getInputBlocks()`

#### getOutputBlocks

    public int getOutputBlocks()

Accessor.

See Also:
  `setOutputBlocks(int)`

#### setOutputBlocks

    public void setOutputBlocks(int outblock)

Accessor.

Parameters:
  `outblock` -
See Also:
  `getOutputBlocks()`

#### getSent

    public int getSent()

Accessor.

See Also:
  `setSent(int)`

#### setSent

    public void setSent(int msgsnd)

Accessor.

Parameters:
  `msgsnd` -
See Also:
  `getSent()`

#### getReceived

    public int getReceived()

Accessor.

See Also:
  `setReceived(int)`

#### setReceived

    public void setReceived(int msgrcv)

Accessor.

Parameters:
  `msgrcv` -
See Also:
  `getReceived()`

#### toString

    public void toString(java.io.Writer stream)
                  throws java.io.IOException

Converts the active state into something meant for human consumption. The method will be called when recursively traversing the instance tree.

Specified by:
  `toString` in class `org.griphyn.vdl.Chimera`
Parameters:
  `stream` - is a stream opened and ready for writing. This can also be a string stream for efficient output.
Throws:
  `java.io.IOException` - if something fishy happens to the stream.

#### toXML

    public void toXML(java.io.Writer stream,
                      java.lang.String indent,
                      java.lang.String namespace)
               throws java.io.IOException

Dump the state of the current element as XML output.

Specified by:
  `toXML` in class `org.griphyn.vdl.Chimera`
Parameters:
  `stream` - is a stream opened and ready for writing. This can also be a string stream for efficient output.
  `indent` - is a `String` of spaces used for pretty printing. The initial amount of spaces should be an empty string. The parameter is used internally for the recursive traversal. If a `null` value is specified, no indentation nor linefeeds will be generated.
  `namespace` - is the XML schema namespace prefix. If neither empty nor null, each element will be prefixed with this prefix, and the root element will map the XML namespace.
Throws:
  `java.io.IOException` - if something fishy happens to the stream.
See Also:
  `BufferedWriter`